Page MenuHomePhabricator

Reduce number of load.php calls on VisualEditor open (down from 3)
Closed, ResolvedPublic8 Story Points

Description

On a regular page load:

We get this (did a full analysis while I had the data in front of me, but focus on "On Edit":

Top:

  • [core] load.php?modules=startup
  • [misc] load.php?modules=.. top queue ...
  • [vector] load.php?modules=ext.vector.footerCleanup (bug 51564)
  • [ve] load.php?modules=ext.visualEditor.viewPageTarget.init
  • [core] load.php?modules=site

Bottom:

  • [misc] load.php?modules=.. bottom queue ...
  • [vector] load.php?modules=ext.vector.collapsibleNav (bug 51564)
  • [misc] load.php?modules=.. jquery.ui ... (dependency of something in the bottom queue, separate cache group)

On Edit:

  • [ve] load.php?modules=ext.visualEditor.base,mediawiki,viewPageTarget|jquery.visibleText|oojs|unicodejs.wordbreak
  • [ve] load.php?modules=jquery.byteLength,byteLimit|mediawiki.api.edit|mediawiki.feedback|ext.visualEditor.core,icons-vector|ext.visualEditor.viewPageTarget.icons-vector|rangy
  • [ve] load.php?modules=ext.visualEditor.specialMessages
  • [ve] api.php POST action=visualeditor & paction=parse
  • [ve] api.php?action=query&meta=userinfo

These shouldn't be 3 separate load.php requests. Ideally it'd be 1, but we should at least cut it down to 2. We should figure out why they are split.

Details

Reference
bz51569
Related Gerrit Patches:
mediawiki/extensions/VisualEditor : masterLoad RL modules in one load.php request, rather than in two stages
mediawiki/extensions/VisualEditor : wmf/1.25wmf21Load RL modules in one load.php request, rather than in two stages

Event Timeline

bzimport raised the priority of this task from to High.Nov 22 2014, 1:42 AM
bzimport added a project: Technical-Debt.
bzimport set Reference to bz51569.
Krinkle created this task.Jul 17 2013, 7:26 PM
Jdforrester-WMF renamed this task from VisualEditor: Reduce number of load.php on edit (down from 3) to Reduce number of load.php calls on VisualEditor open (down from 3).Dec 2 2014, 9:40 PM
Jdforrester-WMF set Security to None.
Catrope claimed this task.Feb 25 2015, 11:10 PM
Catrope edited a custom field.
Catrope moved this task from Backlog to Doing on the VisualEditor-Performance board.

Change 193026 had a related patch set uploaded (by Jforrester):
[WIP] Factor out loading code into TargetLoader

https://gerrit.wikimedia.org/r/193026

Krinkle added a comment.EditedMar 15 2015, 1:26 AM

Saves 1 request and 3KB.

From 20 total request (521KB), to 19 total requests (518KB).

Tested on localhost. (Page view + load editor; includes two EventLogging requests and some images).

Change 193026 merged by jenkins-bot:
Load RL modules in one load.php request, rather than in two stages

https://gerrit.wikimedia.org/r/193026

Jdforrester-WMF closed this task as Resolved.Mar 15 2015, 3:04 AM
Jdforrester-WMF moved this task from Accepted to Done on the VisualEditor 2014/15 Q3 blockers board.
Jdforrester-WMF moved this task from Blocked to Q4 on the VisualEditor board.Mar 15 2015, 3:20 AM

Change 197402 had a related patch set uploaded (by Jforrester):
Load RL modules in one load.php request, rather than in two stages

https://gerrit.wikimedia.org/r/197402

Change 197402 merged by jenkins-bot:
Load RL modules in one load.php request, rather than in two stages

https://gerrit.wikimedia.org/r/197402

ori moved this task from Doing to Done on the VisualEditor-Performance board.Mar 19 2015, 9:48 PM